diff --git a/mysql-test/suite/perfschema/t/rewritten_queries.test b/mysql-test/suite/perfschema/t/rewritten_queries.test
new file mode 100644
index 00000000000..a1942980631
--- /dev/null
+++ b/mysql-test/suite/perfschema/t/rewritten_queries.test
@@ -0,0 +1,268 @@
+
+# Test requires: sp-protocol/ps-protocol/view-protocol/cursor-protocol disabled
+--source include/no_protocol.inc
+
+--echo
+--echo # Connection 1
+--echo
+connect(con1, localhost, root,,);
+--disable_query_log
+let $con1_thread_id= `SELECT sys.ps_thread_id(NULL)`;
+let $con1_connection_id= `SELECT connection_id()`;
+--enable_query_log
+
+--connection default
+CREATE TABLE test.t1(a int, b varchar(80));
+INSERT INTO test.t1 VALUES (1, "a"), (2, "b"), (3, "c");
+SELECT * FROM test.t1;
+
+BEGIN;
+SELECT * FROM test.t1 FOR UPDATE;
+
+--echo
+--echo # Regular query
+--echo
+--connection con1
+SELECT "This is not secret" as normal_query;
+--connection default
+
+# Wait for con1 to complete cleanup after sending the OK packet.
+let $wait_condition=  select count(*) = 1
+  from performance_schema.threads
+  where
+  PROCESSLIST_INFO is NULL
+  AND THREAD_ID=$con1_thread_id;
+--source include/wait_condition.inc
+
+--source ../include/rewritten_queries.inc
+
+--echo
+--echo # Regular query (in flight)
+--echo
+--connection con1
+--send INSERT INTO test.t1 VALUES (4, "This is not secret");
+--connection default
+
+# Wait for con1 to reach the INSERT code
+let $wait_condition=  select count(*) = 1
+   from performance_schema.metadata_locks
+   where
+   OBJECT_TYPE='TABLE' and
+   OBJECT_SCHEMA='test' and
+   OBJECT_NAME="t1" and
+   OWNER_THREAD_ID=$con1_thread_id;
+--source include/wait_condition.inc
+
+--source ../include/rewritten_queries.inc
+
+COMMIT;
+--connection con1
+--reap
+--connection default
+
+# Wait for con1 to complete cleanup after sending the OK packet.
+let $wait_condition=  select count(*) = 1
+  from performance_schema.threads
+  where
+  PROCESSLIST_INFO is NULL
+  AND THREAD_ID=$con1_thread_id;
+--source include/wait_condition.inc
+
+--source ../include/rewritten_queries.inc
+
+--echo
+--echo # Sensitive query
+--echo
+--connection con1
+CREATE USER alice IDENTIFIED BY 'thisisapassword';
+--connection default
+
+# Wait for con1 to complete cleanup after sending the OK packet.
+let $wait_condition=  select count(*) = 1
+  from performance_schema.threads
+  where
+  PROCESSLIST_INFO is NULL
+  AND THREAD_ID=$con1_thread_id;
+--source include/wait_condition.inc
+
+--source ../include/rewritten_queries.inc
+
+--echo
+--echo # Regular prepared statement (prepare)
+--echo
+--connection con1
+PREPARE stmt FROM "SELECT 'This is not a secret either' as prepared_query";
+--connection default
+
+# Wait for con1 to complete cleanup after sending the OK packet.
+let $wait_condition=  select count(*) = 1
+  from performance_schema.threads
+  where
+  PROCESSLIST_INFO is NULL
+  AND THREAD_ID=$con1_thread_id;
+--source include/wait_condition.inc
+
+--source ../include/rewritten_queries.inc
+
+--echo
+--echo # Regular prepared statement (execute)
+--echo
+--connection con1
+EXECUTE stmt;
+--connection default
+
+# Wait for con1 to complete cleanup after sending the OK packet.
+let $wait_condition=  select count(*) = 1
+  from performance_schema.threads
+  where
+  PROCESSLIST_INFO is NULL
+  AND THREAD_ID=$con1_thread_id;
+--source include/wait_condition.inc
+
+--source ../include/rewritten_queries.inc
+
+--echo
+--echo # Regular prepared statement (deallocate)
+--echo
+--connection con1
+DEALLOCATE PREPARE stmt;
+--connection default
+
+# Wait for con1 to complete cleanup after sending the OK packet.
+let $wait_condition=  select count(*) = 1
+  from performance_schema.threads
+  where
+  PROCESSLIST_INFO is NULL
+  AND THREAD_ID=$con1_thread_id;
+--source include/wait_condition.inc
+
+--source ../include/rewritten_queries.inc
+
+BEGIN;
+SELECT * FROM test.t1 FOR UPDATE;
+
+--echo
+--echo # Regular prepared statement (prepare)
+--echo
+--connection con1
+PREPARE stmt FROM "INSERT INTO test.t1 VALUES (5, 'This is not secret either')";
+--connection default
+
+# Wait for con1 to complete cleanup after sending the OK packet.
+let $wait_condition=  select count(*) = 1
+  from performance_schema.threads
+  where
+  PROCESSLIST_INFO is NULL
+  AND THREAD_ID=$con1_thread_id;
+--source include/wait_condition.inc
+
+--source ../include/rewritten_queries.inc
+
+--echo
+--echo # Regular prepared statement (execute, in flight)
+--echo
+--connection con1
+--send EXECUTE stmt;
+--connection default
+
+# Wait for con1 to reach the EXECUTE code
+let $wait_condition=  select count(*) = 1
+   from performance_schema.metadata_locks
+   where
+   OBJECT_TYPE='TABLE' and
+   OBJECT_SCHEMA='test' and
+   OBJECT_NAME="t1" and
+   OWNER_THREAD_ID=$con1_thread_id;
+--source include/wait_condition.inc
+
+--source ../include/rewritten_queries.inc
+
+COMMIT;
+--connection con1
+--reap
+--connection default
+
+# Wait for con1 to complete cleanup after sending the OK packet.
+let $wait_condition=  select count(*) = 1
+  from performance_schema.threads
+  where
+  PROCESSLIST_INFO is NULL
+  AND THREAD_ID=$con1_thread_id;
+--source include/wait_condition.inc
+
+--source ../include/rewritten_queries.inc
+
+--echo
+--echo # Regular prepared statement (deallocate)
+--echo
+--connection con1
+DEALLOCATE PREPARE stmt;
+--connection default
+
+# Wait for con1 to complete cleanup after sending the OK packet.
+let $wait_condition=  select count(*) = 1
+  from performance_schema.threads
+  where
+  PROCESSLIST_INFO is NULL
+  AND THREAD_ID=$con1_thread_id;
+--source include/wait_condition.inc
+
+--source ../include/rewritten_queries.inc
+
+--echo
+--echo # Sensitive prepared statement (prepare)
+--echo
+--connection con1
+PREPARE stmt FROM "CREATE USER bob IDENTIFIED BY 'thisisapassword'";
+--connection default
+
+# Wait for con1 to complete cleanup after sending the OK packet.
+let $wait_condition=  select count(*) = 1
+  from performance_schema.threads
+  where
+  PROCESSLIST_INFO is NULL
+  AND THREAD_ID=$con1_thread_id;
+--source include/wait_condition.inc
+
+--source ../include/rewritten_queries.inc
+
+--echo
+--echo # Sensitive prepared statement (execute)
+--echo
+--connection con1
+EXECUTE stmt;
+--connection default
+
+# Wait for con1 to complete cleanup after sending the OK packet.
+let $wait_condition=  select count(*) = 1
+  from performance_schema.threads
+  where
+  PROCESSLIST_INFO is NULL
+  AND THREAD_ID=$con1_thread_id;
+--source include/wait_condition.inc
+
+--source ../include/rewritten_queries.inc
+
+--echo
+--echo # Sensitive prepared statement (deallocate)
+--echo
+--connection con1
+DEALLOCATE PREPARE stmt;
+--connection default
+
+# Wait for con1 to complete cleanup after sending the OK packet.
+let $wait_condition=  select count(*) = 1
+  from performance_schema.threads
+  where
+  PROCESSLIST_INFO is NULL
+  AND THREAD_ID=$con1_thread_id;
+--source include/wait_condition.inc
+
+--source ../include/rewritten_queries.inc
+
+--connection default
+--disconnect con1
+
+DROP USER alice;
+DROP USER bob;
+DROP TABLE test.t1;
diff --git a/sql/sql_prepare.cc b/sql/sql_prepare.cc
index 7bfa002c66a..59f52d75172 100644
--- a/sql/sql_prepare.cc
+++ b/sql/sql_prepare.cc
@@ -230,8 +230,7 @@ private:
 ******************************************************************************/
 
 /**
-  Rewrite the current query (to obfuscate passwords etc.) if needed
-  (i.e. only if we'll be writing the query to any of our logs).
+  Rewrite the current query (to obfuscate passwords etc.)
 
   Side-effect: thd->rewritten_query() may be populated with a rewritten
                query.  If the query is not of a rewritable type,
@@ -239,25 +238,19 @@ private:
 
   @param thd                thread handle
 */
-static inline void rewrite_query_if_needed(THD *thd)
+static inline void rewrite_query(THD *thd)
 {
-  bool general= (opt_general_log &&
-                 !(opt_general_log_raw || thd->slave_thread));
-
-  if ((thd->sp_runtime_ctx == NULL) &&
-      (general || opt_slow_log || opt_bin_log)) {
-    /*
-      thd->m_rewritten_query may already contain "PREPARE stmt FROM ..."
-      at this point, so we reset it here so mysql_rewrite_query()
-      won't complain.
-    */
-    thd->reset_rewritten_query();
-    /*
-      Now replace the "PREPARE ..." with the obfuscated version of the
-      actual query were prepare.
-    */
-    mysql_rewrite_query(thd);
-  }
+  /*
+    thd->m_rewritten_query may already contain "PREPARE stmt FROM ..."
+    at this point, so we reset it here so mysql_rewrite_query()
+    won't complain.
+  */
+  thd->reset_rewritten_query();
+  /*
+    Now replace the "PREPARE ..." with the obfuscated version of the
+    actual query were prepare.
+  */
+  mysql_rewrite_query(thd);
 }
 
 /**
@@ -3048,11 +3041,11 @@ Execute_sql_statement::execute_server_code(THD *thd)
   thd->m_statement_psi= NULL;
 
   /*
-    Rewrite first (if needed); execution might replace passwords
+    Rewrite first, execution might replace passwords
     with hashes in situ without flagging it, and then we'd make
     a hash of that hash.
   */
-  rewrite_query_if_needed(thd);
+  rewrite_query(thd);
   log_execute_line(thd);
 
   error= mysql_execute_command(thd) ;
@@ -3408,7 +3401,7 @@ bool Prepared_statement::prepare(const char *query_str, size_t query_length)
 
   lex_end(lex);
 
-  rewrite_query_if_needed(thd);
+  rewrite_query(thd);
 
   if (thd->rewritten_query().length())
   {
@@ -4006,8 +3999,25 @@ bool Prepared_statement::execute(String *expanded_query, bool open_cursor)
           with hashes in situ without flagging it, and then we'd make
           a hash of that hash.
         */
-        rewrite_query_if_needed(thd);
+        rewrite_query(thd);
         log_execute_line(thd);
+
+        const char *display_query_string;
+        int display_query_length;
+
+        if (thd->rewritten_query().length())
+        {
+          display_query_string = thd->rewritten_query().ptr();
+          display_query_length = thd->rewritten_query().length();
+        }
+        else
+        {
+          display_query_string = thd->query().str;
+          display_query_length = thd->query().length;
+        }
+
+        mysql_thread_set_info(display_query_string, display_query_length);
+
         thd->binlog_need_explicit_defaults_ts= lex->binlog_need_explicit_defaults_ts;
         error= mysql_execute_command(thd, true);
         MYSQL_QUERY_EXEC_DONE(error);

